# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from marti_nav_msgs/PlanPoint.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class PlanPoint(genpy.Message):
  _md5sum = "d755606289437b8371d55cbf2789ea2d"
  _type = "marti_nav_msgs/PlanPoint"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Position and heading for this point in the plan
float64 x
float64 y
float64 z
float64 yaw

# Maximum speed in meters per second
float32 speed

# Road details for this point in the plan
# Set to < 0 to mark as invalid
int64 lane_id
int64 segment_id

int32 FLAG_REVERSE = 1
int32 FLAG_STOP_POINT = 2

# Bitmask of common per point boolean flags
int32 flags
"""
  # Pseudo-constants
  FLAG_REVERSE = 1
  FLAG_STOP_POINT = 2

  __slots__ = ['x','y','z','yaw','speed','lane_id','segment_id','flags']
  _slot_types = ['float64','float64','float64','float64','float32','int64','int64','int32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       x,y,z,yaw,speed,lane_id,segment_id,flags

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PlanPoint, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.x is None:
        self.x = 0.
      if self.y is None:
        self.y = 0.
      if self.z is None:
        self.z = 0.
      if self.yaw is None:
        self.yaw = 0.
      if self.speed is None:
        self.speed = 0.
      if self.lane_id is None:
        self.lane_id = 0
      if self.segment_id is None:
        self.segment_id = 0
      if self.flags is None:
        self.flags = 0
    else:
      self.x = 0.
      self.y = 0.
      self.z = 0.
      self.yaw = 0.
      self.speed = 0.
      self.lane_id = 0
      self.segment_id = 0
      self.flags = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_4df2qi().pack(_x.x, _x.y, _x.z, _x.yaw, _x.speed, _x.lane_id, _x.segment_id, _x.flags))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 56
      (_x.x, _x.y, _x.z, _x.yaw, _x.speed, _x.lane_id, _x.segment_id, _x.flags,) = _get_struct_4df2qi().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_4df2qi().pack(_x.x, _x.y, _x.z, _x.yaw, _x.speed, _x.lane_id, _x.segment_id, _x.flags))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 56
      (_x.x, _x.y, _x.z, _x.yaw, _x.speed, _x.lane_id, _x.segment_id, _x.flags,) = _get_struct_4df2qi().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4df2qi = None
def _get_struct_4df2qi():
    global _struct_4df2qi
    if _struct_4df2qi is None:
        _struct_4df2qi = struct.Struct("<4df2qi")
    return _struct_4df2qi
