# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from marti_nav_msgs/VehicleParameters.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VehicleParameters(genpy.Message):
  _md5sum = "f32b5011f4c0796a9b5689959dcf384a"
  _type = "marti_nav_msgs/VehicleParameters"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Set of parameters that describe the motion parameters of a vehicle

# Vehicle's maximum curvature in 1/meters. Should be positive.
float32 max_curvature

# Vehicle's minimum curvature in 1/meters. Should be negative
float32 min_curvature

# Vehicle's maximum allowed lateral acceleration in m/s^2
float32 max_lateral_acceleration

# Vehicle's target lateral acceleration in m/s^2. May be exceeded by vehicle
float32 target_lateral_acceleration

# Vehicle's maximum allowed linear acceleration in m/s^2
float32 max_acceleration

# Vehicle's target linear acceleration in m/s^2
float32 target_acceleration

# Vehicle's maximum linear deceleration in m/s^s. May be exceeded by vehicle
float32 max_deceleration

# Vehicle's target linear deceleration in m/s^2
float32 target_deceleration

# Vehicle's linear acceleration in m/s^2 when stopping at the end of a path segment
float32 stop_deceleration
"""
  __slots__ = ['max_curvature','min_curvature','max_lateral_acceleration','target_lateral_acceleration','max_acceleration','target_acceleration','max_deceleration','target_deceleration','stop_deceleration']
  _slot_types = ['float32','float32','float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       max_curvature,min_curvature,max_lateral_acceleration,target_lateral_acceleration,max_acceleration,target_acceleration,max_deceleration,target_deceleration,stop_deceleration

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleParameters, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.max_curvature is None:
        self.max_curvature = 0.
      if self.min_curvature is None:
        self.min_curvature = 0.
      if self.max_lateral_acceleration is None:
        self.max_lateral_acceleration = 0.
      if self.target_lateral_acceleration is None:
        self.target_lateral_acceleration = 0.
      if self.max_acceleration is None:
        self.max_acceleration = 0.
      if self.target_acceleration is None:
        self.target_acceleration = 0.
      if self.max_deceleration is None:
        self.max_deceleration = 0.
      if self.target_deceleration is None:
        self.target_deceleration = 0.
      if self.stop_deceleration is None:
        self.stop_deceleration = 0.
    else:
      self.max_curvature = 0.
      self.min_curvature = 0.
      self.max_lateral_acceleration = 0.
      self.target_lateral_acceleration = 0.
      self.max_acceleration = 0.
      self.target_acceleration = 0.
      self.max_deceleration = 0.
      self.target_deceleration = 0.
      self.stop_deceleration = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_9f().pack(_x.max_curvature, _x.min_curvature, _x.max_lateral_acceleration, _x.target_lateral_acceleration, _x.max_acceleration, _x.target_acceleration, _x.max_deceleration, _x.target_deceleration, _x.stop_deceleration))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 36
      (_x.max_curvature, _x.min_curvature, _x.max_lateral_acceleration, _x.target_lateral_acceleration, _x.max_acceleration, _x.target_acceleration, _x.max_deceleration, _x.target_deceleration, _x.stop_deceleration,) = _get_struct_9f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_9f().pack(_x.max_curvature, _x.min_curvature, _x.max_lateral_acceleration, _x.target_lateral_acceleration, _x.max_acceleration, _x.target_acceleration, _x.max_deceleration, _x.target_deceleration, _x.stop_deceleration))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 36
      (_x.max_curvature, _x.min_curvature, _x.max_lateral_acceleration, _x.target_lateral_acceleration, _x.max_acceleration, _x.target_acceleration, _x.max_deceleration, _x.target_deceleration, _x.stop_deceleration,) = _get_struct_9f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_9f = None
def _get_struct_9f():
    global _struct_9f
    if _struct_9f is None:
        _struct_9f = struct.Struct("<9f")
    return _struct_9f
